Index: src/Menu_popup.cxx
===================================================================
--- src/Menu_popup.cxx	(revision 6148)
+++ src/Menu_popup.cxx	(working copy)
@@ -542,6 +542,31 @@
   } else {
     Y += Hp;
   }
+
+  // Restrict to monitor area: (we're possibly abandoning the caller's desire for a selected item in this case)
+  if ((Y - Htitle) < MENUAREA.y()) {
+    if(rectangle.y() > 0) {
+      // put the menu just below the mouse
+      Y = rectangle.y() + Htitle;
+    }
+
+    // if it's still out of range, put it just inside the MENUAREA
+    if ((Y - Htitle) < MENUAREA.y()) {
+      Y = MENUAREA.y() + Htitle;
+    }
+  }
+  if (Y > MENUAREA.b()-h()) {
+    if(rectangle.y() > 0) {
+      // put the menu just above the mouse
+      Y = rectangle.y() - h();
+    } 
+
+    // if it's still out of range, put it just inside the MENUAREA
+    if (Y > MENUAREA.b()-h()) {
+       Y = MENUAREA.b()-h();
+    }
+  }
+
   y(Y); // if !group: else {y(Y-2); w(1); h(1);}
   if (title) title->position(X,Y-title->h()-dh/2);
 }
@@ -888,8 +913,7 @@
     for (Widget* w = this; w; w = w->parent())
       rectangle.move(w->x(), w->y());
   } else {
-    rectangle.move(event_x_root()-event_x(),
-		   event_y_root()-event_y());
+    rectangle.move(event_x_root(), event_y_root());
   }
   if (fltk::event() == fltk::PUSH)
     monitor = &Monitor::find(event_x_root(), event_y_root());
